// ===========================================================================
//	CSimpleUDPServer.h			1995-1998 Metrowerks Inc. All rights reserved.
// ===========================================================================

#pragma once

#include <LUDPEndpoint.h>

#include <LSingleDoc.h>
#include <LCaption.h>

#include "CUDPServerThread.h"
#include "CTerminalPane.h"

// ===========================================================================
//		 CSimpleUDPServer
// ===========================================================================

class CUDPServerThread;

class CSimpleUDPServer :	public PP_PowerPlant::LSingleDoc{

public:

							CSimpleUDPServer(
								LCommander* inSuper);
			
	void					ListenToMessage(
								PP_PowerPlant::MessageT		inMessage,
								void *			ioParam);

	virtual PP_PowerPlant::LUDPEndpoint*	GetEndPoint() const;

	virtual void			WaitForUDPData(
								UInt32		inPort);
	
	virtual void			CreateServerWindow(
								UInt32		inPort);

	virtual void			BindCompleted();
	virtual void			BindFailed();
	
	virtual void			ServerThreadDied();
	
	virtual Boolean			AllowSubRemoval(
								LCommander *inSub);
	
	virtual Boolean			AttemptQuitSelf(
								SInt32	inSaveOption);
								
protected:

	virtual					~CSimpleUDPServer();

	PP_PowerPlant::LUDPEndpoint*	mEndpoint;		// our network endpoint object

	CTerminalPane*					mTerminalPane;
	CUDPServerThread*				mServerThread;	// the thread that actually handles the connection
	
	bool							mQuitWhenDone;	// re-issue quit request when disconnect complete
	SInt32							mSaveOption;

	friend class CUDPServerThread;
};
