// ===========================================================================
//	CTCPResponderThread.h		1995-1998 Metrowerks Inc. All rights reserved.
// ===========================================================================

#pragma once

#include <LThread.h>
#include <LListener.h>

#include <LTCPEndpoint.h>
#include "CTerminalPane.h"
#include "CSimpleTCPServer.h"

class CTCPResponder;

// ===========================================================================
//		 CTCPResponderThread
// ===========================================================================
//	The thread that actually does the work of the Server interpreter.
//	Note that typed characters (i.e. data sent to the remote host
//	are NOT handled by this object.) Only incoming data are processed
//	here.

class CTCPResponderThread :	public PP_PowerPlant::LThread,
							public PP_PowerPlant::LListener {


public:
						CTCPResponderThread(
								PP_PowerPlant::LTCPEndpoint*			inNetworkEndpoint,
								CTerminalPane*			inTerminalPane,
								CTCPResponder*				inResponderMaster,
								CSimpleTCPServer*			inMasterServer);
	virtual				~CTCPResponderThread();

	void				StartDisconnect();

	virtual void		ListenToMessage(
							PP_PowerPlant::MessageT		inMessage,
							void			*ioParam);

protected:
	virtual void*		Run();

	PP_PowerPlant::LTCPEndpoint*	mEndpoint;			// network endpoint
	CTerminalPane*					mTerminalPane;		// terminal display for this connection
	CTCPResponder*					mResponderMaster;	// Responder object that spawned this thread
	CSimpleTCPServer*				mMasterServer;		// Master EP that issued the Listen();
	bool							mContinue;
	bool							mInDisconnect;

};
