// ===========================================================================
//	CUDPServerThread.h			1995-1998 Metrowerks Inc. All rights reserved.
// ===========================================================================

#pragma once

#include <LThread.h>

#include <LUDPEndpoint.h>

#include "CSimpleUDPServer.h"
#include "CTerminalPane.h"

class CSimpleUDPServer;

// ===========================================================================
//		 CUDPServerThread
// ===========================================================================
//	The thread that actually does the work of the server responder.
//	Note that typed characters (i.e. data sent to the remote host
//	are NOT handled by this object.) Only incoming data are processed
//	here.

class CUDPServerThread :	public PP_PowerPlant::LThread {

public:
						CUDPServerThread(
								UInt16				inLocalPort,
								PP_PowerPlant::LUDPEndpoint*		inNetworkEndpoint,
								CSimpleUDPServer*	inServerMaster,
								CTerminalPane*		inTerminalPane);
	virtual				~CUDPServerThread();
	
	void				Complete();
	
protected:
	bool				mContinue;
	
	virtual void*		Run();

	PP_PowerPlant::LUDPEndpoint*		mEndpoint;
	CSimpleUDPServer*					mServerMaster;
	UInt16								mMaxConnections;
	UInt16								mPort;
	CTerminalPane*						mTerminalPane;
	
	friend class CSimpleUDPServer;
};
